<%@ page language="java" contentType="text/html; charset=UTF-8"	pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html>
    <head>
      
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <meta name="description" content="Kalendarz majów" />
        <meta name="keywords" content="HTML5, canvas, kalendarz Majów" />
        <link rel="shortcut icon" href="images/dragon.ico" type="image/x-icon" />
        <link rel="stylesheet" type="text/css" href="styles/canvas.css" />
        <script src="scripts/time.js"></script>
        <script src="scripts/maya.js"></script>
        <title>Kalendarz Majów</title>
    </head>

    <body>

        <header>
            <a href="index.jsp"><img border="0" src="images/samsmok.png"
                                      width="120" height="130" alt="Zielony smok: powrót do strony głównej"
                                      title="Zielony Smok: Powrót do strony głównej"></a>

        </header>
        <section>
            <h2>Kalendarz Majów</h2>
            <form style="width: 400px">
                <fieldset>
                    <label for="dzien">Dzień</label> <input style="width: 60px"
                                                            type="number" name="dzien" id="dzien" value="16" step="1" min="1"
                                                            max="31"> <label for="miesiac">Miesiąc</label> <input
                                                            style="width: 60px" type="number" name="miesiac" id="miesiac"
                                                            value="6" step="1" min="1" max="12"> <label for="rok">Rok</label>
                    <input style="width: 60px" type="number" name="rok" id="rok"
                           value="2015" step="1" min="2005" max="2025">

                </fieldset>
            </form>
            <p>KO = Kalendarz Okrągły, DR = Długa Rachuba</p>
            <canvas id="canvas" width="450" height="455"
                    style="border: 1px solid #238E3E;">Zawartość możesz zobaczyć w 
                przeglądarce obsługującej element &lt;canvas&gt; 
                z kontekstem &#034;2d&#034;</canvas>
            <script type="text/javascript">
                var cv = document.getElementById("canvas");
                var ctx = cv.getContext("2d");
                var width = cv.width;
                var height = cv.height;
                var a = 60;
                var b = 3600;
                var c = 86400;
                var date = new Date();
                var rr = date.getFullYear();
                var mm = date.getMonth();
                var dd = date.getDate();
                var httpRequest;
                var mayaDate;

                var $ = function (id) {
                    return document.getElementById(id);
                };
                //ustawienie kontrolek kalendarza na datę bieżącą;
                var setDate = function (rr, mm, dd) {
                    $("rok").value = rr;
                    $("rok").min = rr - 100;
                    $("rok").max = rr + 100;
                    $("miesiac").value = mm + 1;
                    var leap = isLeapYear(rr);
                    var days_max;
                    if (mm === 3 || mm === 5 || mm === 8 || mm === 10) {
                        days_max = 30;
                    } else if (mm === 1) {
                        if (leap) {
                            days_max = 29;
                        } else {
                            days_max = 28;
                        }
                    } else {
                        days_max = 31;
                    }
                    if ($("dzien").value > days_max) {
                        $("dzien").value = days_max;
                        dd = days_max;
                    }
                    $("dzien").value = dd;
                    $("dzien").max = days_max;
                };

                var sendDate = function () {
                    var aktData = new Object();
                    aktData.rr = rr.toString();
                    aktData.mm = (mm + 1).toString();
                    aktData.dd = dd.toString();
                    var gcdate = JSON.stringify(aktData);
                    httpRequest = new XMLHttpRequest();
                    httpRequest.onreadystatechange = getDate;
                    httpRequest.open("Get", "/calenm/maya?gcdate="
                            + escape(gcdate), true);
                    httpRequest.setRequestHeader("Cache-Control", "no-cache");
                    httpRequest.send();
                };
                var getDate = function () {
                    if (httpRequest.readyState === 4 && httpRequest.status === 200) {
                        mayaDate = JSON.parse(httpRequest.responseText);
                        ctx.fillStyle = "blue";
                        ctx.clearRect(0, 0, width, height);
                        ctx.font = "25px sans-serif";
                        ctx.fillText("Długa Rachuba: " + mayaDate.lc, 10, 25);
                        ctx.fillText("Dzień Majów: " + mayaDate.lcValue
                                + " z 1898000", 40, 60);
                        ctx.fillText("Kalendarz Okrągły: ", 10, 95);
                        ctx.fillText("Cykl DR: " + mayaDate.crCycle, 40, 130);
                        ctx.fillText("Dzien KO: " + mayaDate.crDay, 40, 165);
                        ctx.fillText("Tzolkin: " + mayaDate.tzDd + " "
                                + mayaDate.tzName, 10, 200);
                        ctx.fillText("Dzień cyklu: " + mayaDate.tzDayY + " z 260", 40, 235);
                        ctx.fillText("Cykl KO: " + mayaDate.tzCycle, 40, 270);
                        ctx.fillText("Cykl DR: " + mayaDate.tzCycleTotal, 40, 305);
                        //-
                        ctx.fillText("Haab: " + mayaDate.haDd + " "
                                + mayaDate.haName, 10, 340);
                        ctx.fillText("Dzień cyklu: " + mayaDate.haDayY + " z 365", 40, 375);
                        ctx.fillText("Cykl KO: " + mayaDate.haCycle, 40, 410);
                        ctx.fillText("Cykl DR: " + mayaDate.haCycleTotal, 40, 440);
                        var tzImage = new Image();
                        tzImage.onload = function () {
                            ctx.drawImage(this, 310, 210);
                        };
                        tzImage.src = "images/tz100j/" + mayaDate.tzName + "100j.png";
                        var haImage = new Image();
                        haImage.onload = function () {
                            ctx.drawImage(this, 310, 350);
                        };
                        haImage.src = "images/ha100j/" + mayaDate.haName + "100j.png";
                    }
                };

                $("rok").onchange = function () {
                    rr = $("rok").value;
                    mm = $("miesiac").value - 1;
                    dd = $("dzien").value;
                    setDate(rr, mm, dd);
                    sendDate();
                };
                $("miesiac").onchange = function () {
                    rr = $("rok").value;
                    mm = $("miesiac").value - 1;
                    dd = $("dzien").value;
                    setDate(rr, mm, dd);
                    sendDate();
                };
                $("dzien").onchange = function () {
                    rr = $("rok").value;
                    mm = $("miesiac").value - 1;
                    dd = $("dzien").value;
                    setDate(rr, mm, dd);
                    sendDate();
                };
                setDate(rr, mm, dd);
                sendDate();
            </script>

            <p class="listing">Listing</p>
            <pre></pre>
        </section>

</body>
</html>