package maya;

public class CalendarRound{
	private final Tzolkin tzolkin;
	private final Haab haab;
	private int dayOfCR;

	public CalendarRound(){
		this.tzolkin = new Tzolkin(CU.TZSTART.getDayOfYear());
		this.haab = new Haab(CU.HASTART.getDayOfYear());
		dayOfCR = CU.dayOfCR(tzolkin, haab);
	}

	public void addDays(int daysAdded) {
		if(daysAdded < 0){
			throw new IllegalArgumentException(
					"liczba dni dodanych nie może być mniejsza od 0");
		}
		int tempDays = this.dayOfCR + daysAdded;
		this.dayOfCR = CU.amod(tempDays, CU.CR_LENGTH);
		this.tzolkin.addDays(daysAdded);
		this.haab.addDays(daysAdded);
	}

	public int getDayOfCR() {
		return dayOfCR;
	}

	public Tzolkin getTzolkin() {
		return tzolkin;
	}

	public Haab getHaab() {
		return haab;
	}

	@Override
	public String toString() {
		return "CR(day: " + dayOfCR + ", " + tzolkin + ", " + haab + ")";
	}
}
