package maya;

public class Haab{
	private int dd;
	private int mm;
	private String name;
	private int dayOfYear;

	public Haab(int dd, String name){
		if(!CU.isValidHaab(dd, name)){
			throw new IllegalArgumentException("niewłaściwy argument");
		}
		this.dd = dd;
		this.name = name;
		this.mm = CU.mmHaabNumber(name);
		this.dayOfYear = CU.dayOfHaabYear(dd, mm);
	}

	public Haab(int dayOfYear){
		if(!CU.isValidDayOfHaabYear(dayOfYear)){
			throw new IllegalArgumentException("niewłaściwa liczba dnia");
		}
		this.dayOfYear = dayOfYear;
		this.dd = CU.amod(dayOfYear, CU.HAAB_DAYS) - 1;
		this.mm = ((dayOfYear - 1) / CU.HAAB_DAYS) + 1;
		this.name = CU.HAAB_MMS[mm - 1];
	}

	public int getDayOfYear() {
		return dayOfYear;
	}

	public void addDays(int daysAdded) {
		if(daysAdded < 0){
			throw new IllegalArgumentException(
					"liczba dni dodanych nie może być mniejsza od 0");
		}
		int tempDays = this.dayOfYear + daysAdded;
		int tempDayOfYear = CU.amod(tempDays, CU.HAAB_YEAR_LENGTH);
		Haab tempHa = new Haab(tempDayOfYear);
		this.dayOfYear = tempHa.dayOfYear;
		this.dd = tempHa.dd;
		this.mm = tempHa.mm;
		this.name = tempHa.name;
	}

	public int getDd() {
		return dd;
	}

	public String getName() {
		return name;
	}

	@Override
	public String toString() {
		return dd + " " + name;
	}
}
