package maya;

import java.io.*;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import jakarta.servlet.*;
import jakarta.servlet.http.*;
import org.json.simple.*;
import org.json.simple.parser.*;

public class MayaCalendarServlet extends HttpServlet{
	private static final long serialVersionUID = 7772065702934658508L;
 private static final Logger LOGGER = Logger.getLogger(MayaCalendarServlet.class.getName());
	protected void process(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		String gcdate = request.getParameter("gcdate");
		JSONParser parser = new JSONParser();
		Object obj;
		JSONObject jobj = null;
		int rr=0;
		int mm=0;
		int dd=0;
		try{
			obj = parser.parse(gcdate);
			jobj = (JSONObject)obj;
		} catch (ParseException e){
			LOGGER.log(Level.SEVERE, e.getMessage());
		}               
                if(jobj!=null){
		rr = Integer.parseInt((String)jobj.get("rr"));                
		mm = Integer.parseInt((String)jobj.get("mm"));
		dd = Integer.parseInt((String)jobj.get("dd"));
                }                
		MayaDate md = CU.ymdToMayaDate(new YMD(rr, mm, dd + 0.5));
		LongCount lc = md.getLongCount();
		int lcValue = lc.getValue();
		CalendarRound cr = md.getCalendarRound();
		int crDay = cr.getDayOfCR();
		int crCycle = (lcValue / CU.CR_LENGTH) + 1;
		Tzolkin tz = cr.getTzolkin();
		int tzDayY = tz.getDayOfYear();
		int tzCycle = (crDay / CU.TZOLKIN_YEAR_LENGTH) + 1;
		int tzCycleTotal = (lcValue / CU.TZOLKIN_YEAR_LENGTH) + 1;
		int tzDd = tz.getDd();
		String tzName = tz.getName();
		Haab ha = cr.getHaab();
		int haDayY = ha.getDayOfYear();
		int haCycle = (crDay / CU.HAAB_YEAR_LENGTH) + 1;
		int haCycleTotal = (lcValue / CU.HAAB_YEAR_LENGTH) + 1;
		int haDd = ha.getDd();
		String haName = ha.getName();
		response.setContentType("application/json");
		response.setHeader("Cache-Control", "no-cache");
		response.setCharacterEncoding("utf-8");
		JSONObject mayaDate = new JSONObject();
		@SuppressWarnings("unchecked")
		HashMap<String, Object> map = mayaDate;
		map.put("lc", lc.toString());//"13.0.2.4.9"
		map.put("lcValue", lcValue);//18728091		
		map.put("crDay", crDay);
		map.put("crCycle", crCycle);
		map.put("tzDayY", tzDayY);
		map.put("tzCycle", tzCycle);
		map.put("tzCycleTotal", tzCycleTotal);
		map.put("tzDd", tzDd);
		map.put("tzName", tzName);
		map.put("haDayY", haDayY);
		map.put("haCycle", haCycle);
		map.put("haCycleTotal", haCycleTotal);
		map.put("haDd", haDd);
		map.put("haName", haName);
		response.getWriter().write(mayaDate.toJSONString());
		
	}

	@Override
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		process(request, response);
	}

	@Override
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		process(request, response);
	}

	@Override
	public String getServletInfo() {
		return "Przyjmuje stary samochód i przerabia go na nowy, a potem odsyła z powrotem.";
	}
}