package maya;

public class YMD{
	private int yy;
	private int mm;
	private double dd;

	public YMD(int yy, int mm, double dd){
		if(CU.isValidYMDDate(yy, mm, dd)){
			this.yy = yy;
			this.mm = mm;
			this.dd = dd;
		}
		else{
			throw new IllegalArgumentException("nieprawidłowa data");
		}
	}

	/**
	 * Pobiera rok
	 * @return - zwraca rok
	 */
	public int getYy() {
		return yy;
	}

	/**
	 * Pobiera miesiąc
	 * @return - zwraca miesiąć
	 */
	public int getMm() {
		return mm;
	}

	/**
	 * Pobiera dzień
	 * @return - zwraca dzień
	 */
	public double getDd() {
		return dd;
	}

	public void setYy(int yy) {
		if(CU.isValidYMDDate(yy, this.mm, this.dd)){
			this.yy = yy;
		}
	}

	public void setMm(int mm) {
		if(CU.isValidYMDDate(this.yy, mm, this.dd)){
			this.mm = mm;
		}
	}

	public void setDd(double dd) {
		if(CU.isValidYMDDate(this.yy, this.mm, dd)){
			this.dd = dd;
		}
	}

	@Override
	public String toString() {
		return yy + " " + mm + " " + dd;
	}
}
